#include <windows.h>
#include <vector>
#include <cstdlib>
#include <ctime>
#define ASCIIELTOLAS 60                                                         // az ASCII tbla hnyadik elemtl kezdje a figurk fajtit

class EkkoTabla{
      private:
              short tablameret;                                                 // tbla mrete (kirs szempontjbl max. 10 a j, br megoldhat nagyobbra)
              short figurak;                                                    // figuratpusok szma (mivel a szn ebbl alakul ki, 4 bitesnl ez se legyen nagyobb,
                                                                                //  br megoldhat lenne ( setcolor(x-(x/16)*16) ), csak gy ismtldnnek a sznek egy-kt figurnl)
              char mezo[10][10];                                                // a tbla (itt is max.10 )
              std::vector<short> torl;                                          // kies darabok koordintaprjnak gyjtvektora
      public:
             static long pontszam;                                              // aktulis pontszm
             static short palyaId;                                              // aktulis plya
             
             EkkoTabla::EkkoTabla(short meret, short fig);                      // plyakonstruktor
             void gotoxy(short x, short y);                                     // (kpernyn koordintra ugrs)
             void setcolor(char color);                                         // (betszn (s httrszn) belltsa  (bitek: httr:[villogs][R][G][B]bet:[vilgos][R][G][B]) )
             void fejlec();                                                     // fejlc s vezrlkeret kirsa
             void general();                                                    // tblafeltlts vletlen elemekkel
             void kiir();                                                       // a tbla, valamint a plyaszm/sorszm/kv.plyapontkvetelmny kirsa
             void kiszur();                                                     // a kiejtend elemek koordintjnak vektorba gyjtse
             bool vanmeg();                                                     // van-e mg elem a vektorban, azaz kiejtettnk-e mindent, amit kellett
             void kiejt();                                                      // a vektorban szerepl koordintk alapjn a kiejtend elemek nullzsa, majd j kvek "bepotyogtatsa"
             void ekkoCsere();                                                  // kt kk cserjhez koordintabekrs, majd ellenrzs
             void cserel(short x_ori, short y_ori, short x_cel, short x_cel);   // az kkvek tnyleges cserje
             void gyozelem();                                                   // a jtk vgn a gyzelmi zenet
};

EkkoTabla::EkkoTabla(short meret, short fig){                                   // mret a kperny miatt max.10, fig sznek miatt max. 15, de az kikszblhet lenne ( setcolor(x-(x/16)*16) )
                       ++palyaId;                                               // plya szmnak nvelse
                       tablameret=meret;                                        // tblamret belltsa az argumentumban megadottra
                       figurak=fig;                                             // figuratpusszm belltsa az argumentumban megadottra
                       
                       fejlec();                                                // fejlc kirsa
                       general();                                               // j tbla generlsa vletlen elemekkel
                       kiir();                                                  // ezen tblt rja is rgtn ki
                       kiszur();                                                //  valamint szrje ki a beavatkozs nlkl is keletkezett sorokat
                       while(vanmeg()){                                         //   amg csak van mg
                                       kiejt();
                                       kiir();
                                       kiszur();
                       }
}

void EkkoTabla::general(){                                                      // tblaelemek (kkvek) vletlen generlsa
     srand(time(NULL));                                                         // vletlenszm-genertor (jra)inicializlsa
     for(short i=0; i<tablameret; ++i)                                          // minden sorban
               for(short j=0; j<tablameret; ++j)                                //  minden elemre
                         mezo[i][j] = ASCIIELTOLAS + (rand()%figurak + 1);      //   tegyen be egy j vletlen elemet (ASCII tartomny figuratpusszm mretben)
}

void EkkoTabla::gotoxy(short x, short y){                                       // kpernyn ugrs egy megadott koordintra
     COORD coord;                                                               // j koordinta
     coord.X = x; coord.Y = y;                                                  // koordinthoz X s Y hozzrendelse
     SetConsoleCursorPosition(GetStdHandle(STD_OUTPUT_HANDLE), coord);          // ugrs erre a koordintra
}

void EkkoTabla::setcolor(char color){                                           // szn belltsa
    HANDLE hcon = GetStdHandle(STD_OUTPUT_HANDLE);                              // standard kimenet hozzrendelse
    SetConsoleTextAttribute(hcon,(unsigned short)color);                        // szvegattribtum vltoztatsa
}

void EkkoTabla::fejlec(){                                                       // fejlc s vezrlkeret kirsa
     gotoxy(0,0);
     setcolor(31);
     std::cout<<"********************************************************************************";
     std::cout<<"************          M i N E R A L   M A D N E S S                 ************";
     std::cout<<"********************************************************************************";
     gotoxy(0,3); setcolor(15); for(int i=0; i<1759; ++i) std::cout<<' ';       // kptrls
     setcolor(79);
     gotoxy(44,13); std::cout<<"****************************";
     gotoxy(44,14); std::cout<<"*                          *";
     gotoxy(44,15); std::cout<<"*                          *";
     gotoxy(44,16); std::cout<<"*                          *";
     gotoxy(44,17); std::cout<<"*                          *";
     gotoxy(44,18); std::cout<<"*                          *";
     gotoxy(44,19); std::cout<<"****************************";
};

void EkkoTabla::kiir(){                                                         // a tbla kirsa
     short sorszam=0, oszlopszam;                                               // sor- s oszlopindex-vltoz
     gotoxy(11,4);
     setcolor(79);
     for(oszlopszam=1; oszlopszam<(1+tablameret); ++oszlopszam) {
                       std::cout<<' '<<oszlopszam;                              // legfell az oszlopszmok kirsa
                       if(oszlopszam<10) std::cout<<' ';                        // ha mr ktjegy, ne tegyen szkzt, br gy sszefolyik
     }
     gotoxy(0,3);
     setcolor(1);
     for(short i=0; i<tablameret; ++i){                                         // a tnyleges tblakirs
               setcolor(15); std::cout<<"\n\n        ";                         // sor eleji soremels s rvid ugrs
               setcolor(79); ++sorszam; std::cout<<' '<<sorszam;                // sorszmkirs
                             if(sorszam<10) std::cout<<' ';                     // ktjegy esetn itt sincs szkz
               setcolor(15); std::cout<<' ';                                    // egy res hely
               for(short j=0; j<tablameret; ++j){                               // az elemek kirsa
                         setcolor(mezo[i][j] - ASCIIELTOLAS);                   // szn 1-15-ig, ki kell vonni a mennyisget amennyivel eltoltuk a szimblumokat az ASCII tbla elejtl
                         std::cout<<mezo[i][j]<<"  ";                           // az kkvek kirsa mint ASCII karakter
               }
     }
     
     setcolor(10);
     gotoxy(44,8);  std::cout<<"Palya:             "<<palyaId;                  // plya sorszmnak kirsa
     gotoxy(44,9);  std::cout<<"Pontszam:          "<<pontszam<<"        ";     // aktulis pontszm kirsa
     gotoxy(44,10); std::cout<<"Kov.palyahoz kell: "<<palyaId*palyaId*100;      // kv. plyhoz szksges pontszm kirsa
}

void EkkoTabla::kiszur(){                                                       // elemszrs metdusa (keletkezett kksorok)
     torl.clear();                                                              // (a biztonsg kedvrt a vektort kirtjk)
     short volt_darab=1;                                                        // a vltoz, amelyben azt troljuk, hogy hny azonos darab volt mr egyms mellett/alatt
     short elozo_tipus=0;                                                       // az sszehasonltshoz hasznlt vltoz, az elz kk tpust trolja
     int reszpontszam=0;                                                        // a kiejts pontozshoz hasznlt rszpontszm vltoz
     
     for(short i=0; i<tablameret; ++i){                                         // vgigpsztzza
               for(short j=0; j<tablameret; ++j){                               //  az egsz tblt
                         if(mezo[i][j]==elozo_tipus){                           // ha kt azonos tpust tallt egyms mellett
                                ++volt_darab;                                   //  nveli a vltozt, amiben ezt jeleztk
                                if(volt_darab==3){                              //  ha mr hrom azonos volt
                                       torl.push_back(i); torl.push_back(j-2);  //  akkor beteszi mindhrom elem koordintit a vektorba
                                       torl.push_back(i); torl.push_back(j-1);
                                       torl.push_back(i); torl.push_back(j);
                                       reszpontszam+=4*palyaId;                 //  rszpontszm nvelse a plya fggvnyben 4 tbbszrsvel
                                } else if(volt_darab>3){                        // ha mr tbb, mint 3 darab volt
                                       torl.push_back(i); torl.push_back(j);    //  akkor szintn berakjuk az j elemet
                                       reszpontszam+=reszpontszam/2;            //  az eddigi rszpontszmot pedig a msflszeresre nveljk (bnusz)
                                }
                         } else {                                               // ha pedig nem tallt kt azonos tpust
                                elozo_tipus=mezo[i][j];                         //  a kvetkezre val tugrs eltt ezt az kktpust trolja elz tpusnak
                                volt_darab=1;                                   //  visszalltja a darabszmllt 1-re
                                pontszam+=reszpontszam; reszpontszam=0;         //  a rszpontszmmal megnveli az sszpontszmot
                         }
               }
               volt_darab=1;                                                    // a sorok vgn a kt vltozt visszalltja alaprtkre,
               elozo_tipus=0;                                                   //  hogy a sor vgn lev elemet ne hasonltsa ssze a KVETKEZ sor elejn lv elemmel
     }
     
     for(short j=0; j<tablameret; ++j){                                         // Fggleges irnyban ugyanez, csak a megfelel koordintk cserjvel
               for(short i=0; i<tablameret; ++i){
                         if(mezo[i][j]==elozo_tipus){
                                ++volt_darab;
                                if(volt_darab==3){
                                       torl.push_back(i-2); torl.push_back(j);
                                       torl.push_back(i-1); torl.push_back(j);
                                       torl.push_back(i); torl.push_back(j);
                                       reszpontszam+=4*palyaId;
                                } else if(volt_darab>3){
                                       torl.push_back(i); torl.push_back(j);
                                       reszpontszam+=reszpontszam/2;
                                }
                         } else {
                                elozo_tipus=mezo[i][j];
                                volt_darab=1;
                                pontszam+=reszpontszam; reszpontszam=0;
                         }
               }
               volt_darab=1;
               elozo_tipus=0;
     }
}

bool EkkoTabla::vanmeg(){                                                       // "van-e mg" metdus
     if(torl.empty()) return false; else return true;                           // ha a vektor res, hamisat, ha van mg kiejtend elem benne, igazat ad vissza
}

void EkkoTabla::kiejt(){                                                        // Kiejts metdusa
     short x,y;                                                                 // Elemek nullzsa, ahol kijtt 3 vagy tbb egyms mellett
     while(!torl.empty()){                                                      // amg van elem
          y=torl.back(); torl.pop_back();                                       //  kivesszk a koordintkat (elszr y, majd x), troljuk, majd a verembl ket trljk
          x=torl.back(); torl.pop_back();
          mezo[x][y]=0;                                                         // a mentett koordintkat felhasznlva a mezt nullzzuk
     }
     
     Sleep(1000);                                                               // a vrakozs kt szrs kztt
     
     srand(time(NULL));                                                         // vletlenszm-genertor (jra)inicializlsa
     short lyuk;                                                                // vltoz annak trolsra, hogy van-e "lyuk" az oszlopban, azaz 0 rtk elem
     for(short j=0; j<tablameret; ++j){                                         // oszloponknt vizsgljuk
               do{
                  lyuk=0;                                                       // a "lyukszmll" 0-rl indul
                  for(short i=0; i<tablameret; ++i){                            // minden elemnl tnzzk az oszlopban,
                             if(!mezo[i][j]) {                                  // hogy tartalmuk 0-e... ha igen,
                                             ++lyuk;                            //  a lyukak szmt nveljk
                                             if(!i){                            //  ha a sorszm 0, akkor az els sorban volt, gy nincs felette elem, ezrt
                                                    mezo[i][j]=(ASCIIELTOLAS + rand()%figurak + 1);      // egy j vletlen elemet kap
                                             } else {                           //  klnben
                                                    mezo[i][j]=mezo[i-1][j];    //   rdobjuk a felette lev elemet
                                                    mezo[i-1][j]=0;             //   a felette lev elemben lesz az j "lyuk"
                                                    break;                      //   jraindtja a ciklust
                                             }
                                             kiir();Sleep(300);                 // az animci miatt mindig kirjuk jra, s 0.3 msodpercet vrunk
                             }
                   }
               } while(lyuk);                                                   // minden oszlopot addig vizsglunk, amg van benne res hely
     }
}

void EkkoTabla::ekkoCsere(){                                                    // koordintabevitel, majd helyes bevitt adatok esetn csere
     short x_ori, y_ori, x_cel, y_cel;                                          // a forrs- s a clkoordinta
     char irany;                                                                // a ksbb bekrt irny
     setcolor(79);                                                              // kirsok
     gotoxy(48,15); std::cout<<"Mit csereljek:      ";
     gotoxy(48,16); std::cout<<"Sor[   ] Oszlop[   ]";
     gotoxy(53,16); std::cin>>x_ori; x_ori-=1;                                  // koordintk bekrse (majd 1-gyel cskkents, hogy majd helyesen tudjuk indexvltoznak hasznlni)
     gotoxy(65,16); std::cin>>y_ori; y_ori-=1;
     x_cel=x_ori; y_cel=y_ori;                                                  // a clkoord. egyelre egyezzen meg az originl koordintval
     gotoxy(48,17); std::cout<<"Merre? (w/a/s/d) [ ]";                          // kirs
     gotoxy(66,17);
     std::cin.ignore(10,'\n');                                                  // irnyparancs betjnek bekrse, eltte a bemenetrl kiszrjk az esetlegesen bennmaradt Entereket
     std::cin.get(irany);
     gotoxy(48,17);                                                             // esetleges hibazenet-kirs miatt ugrunk erre a koordintra
     switch(irany){                                                             // a megadott irnynak megfelelen megvltoztatjuk a clkoordintt
                   case 'w': case 'W': {
                        if(x_ori==0) std::cout<<"Nincs feljebb!      ";         // termszetesen a tbla szlnl kijjebb nem mehetnk
                                    else x_cel--;
                        break;
                   }
                   case 's': case 'S': {
                        if(x_ori==tablameret-1) std::cout<<"Nincs lejjebb!      ";
                                    else x_cel++;
                        break;
                   }
                   case 'a': case 'A': {
                        if(y_ori==0) std::cout<<"Nincs balrabb!      ";
                                    else y_cel--;
                        break;
                   }
                   case 'd': case 'D': {
                        if(y_ori==tablameret-1) std::cout<<"Nincs jobrabb!      ";
                                    else y_cel++;
                        break;
                   }
                   default: {
                            std::cout<<"Ervenytelen irany!    ";                // csak a w,a,s,d betket fogadjuk el
                            break;
                   }
     };
     if((x_ori<0)||(x_ori>=tablameret)||(y_ori<0)||(y_ori>=tablameret)) {       // tbln kvlre megadott koordintkra ne csinljon semmit
               if(x_ori==-1 && y_ori==-1) {                                     // 0,0 megadsa esetn (mivel ugye 1-et levontunk) -1,-1 ktt ki
                           general();                                           //  gy a plyt jragenerljuk
                           pontszam=(palyaId-1)*(palyaId-1)*100;                //  a pontszmot pedig "bntetskppen" a plya minimumpontszm-rtkre vesszk vissza
                           kiir();                                              //  kirjuk az j tblt
                       
               } else {
               gotoxy(48,17); std::cout<<"Hamis koordinatak!  ";                // egybknt hibazenet
               }
     }
     else if((x_ori!=x_cel)||(y_ori!=y_cel)) {                                  // amennyiben rvnyes parancsokat adtunk meg, a koordintk megvltoztak
              cserel(x_ori, y_ori, x_cel, y_cel);                               // az elemeket cserljk, s most megvizsgljuk, hogy rvnyes csere volt-e (kijtt-e j sor)
              kiir();                                                           // kirs (hogy a mvelet ltszdjon)
              kiszur();                                                         // szrs (van-e egyltaln j sor)
              if(vanmeg()) kiejt();                                             // ha igen, egy kiejtssel nyugtzzuk
                  else {                                                        // ha nem, akkor
                       Sleep(1000);                                             //  vrunk egy msodpercet, hadd lssa a jtkos azrt, hogy rosszat adott meg
                       cserel(x_cel, y_cel, x_ori, y_ori);                      //  visszacserljk az elemeket, mivel rvnytelen volt
                  }
              kiir();                                                           // ha megvltozott, az jat rjuk ki, ha nem, akkor a visszalltott eredetit
     }
}

void EkkoTabla::cserel(short x_ori, short y_ori, short x_cel, short y_cel){     // kt elem egyszer cserje
     char temp = mezo[x_ori][y_ori];
     mezo[x_ori][y_ori] = mezo[x_cel][y_cel];
     mezo[x_cel][y_cel] = temp;
}

void EkkoTabla::gyozelem(){                                                     // gyzelmi kperny, Enterig vr
     fejlec(); gotoxy(48,16); std::cout<<"G Y O Z E L E M !!!";
     std::cin.ignore(10,'\n'); std::cin.get();
}
